uniform sampler2D texture;

vec3 mod289(vec3 x) {
  return x - floor(x * (1.0 / 289.0)) * 289.0;
}

vec2 mod289(vec2 x) {
  return x - floor(x * (1.0 / 289.0)) * 289.0;
}

vec3 permute(vec3 x) {
  return mod289(((x*34.0)+1.0)*x);
}

float snoise(vec2 v)
  {
  const vec4 C = vec4(0.211324865405187,  // (3.0-sqrt(3.0))/6.0
                      0.366025403784439,  // 0.5*(sqrt(3.0)-1.0)
                     -0.577350269189626,  // -1.0 + 2.0 * C.x
                      0.024390243902439); // 1.0 / 41.0
// First corner
  vec2 i  = floor(v + dot(v, C.yy) );
  vec2 x0 = v -   i + dot(i, C.xx);

// Other corners
  vec2 i1;
  //i1.x = step( x0.y, x0.x ); // x0.x > x0.y ? 1.0 : 0.0
  //i1.y = 1.0 - i1.x;
  i1 = (x0.x > x0.y) ? vec2(1.0, 0.0) : vec2(0.0, 1.0);
  // x0 = x0 - 0.0 + 0.0 * C.xx ;
  // x1 = x0 - i1 + 1.0 * C.xx ;
  // x2 = x0 - 1.0 + 2.0 * C.xx ;
  vec4 x12 = x0.xyxy + C.xxzz;
  x12.xy -= i1;

// Permutations
  i = mod289(i); // Avoid truncation effects in permutation
  vec3 p = permute( permute( i.y + vec3(0.0, i1.y, 1.0 ))
		+ i.x + vec3(0.0, i1.x, 1.0 ));

  vec3 m = max(0.5 - vec3(dot(x0,x0), dot(x12.xy,x12.xy), dot(x12.zw,x12.zw)), 0.0);
  m = m*m ;
  m = m*m ;

// Gradients: 41 points uniformly over a line, mapped onto a diamond.
// The ring size 17*17 = 289 is close to a multiple of 41 (41*7 = 287)

  vec3 x = 2.0 * fract(p * C.www) - 1.0;
  vec3 h = abs(x) - 0.5;
  vec3 ox = floor(x + 0.5);
  vec3 a0 = x - ox;

// Normalise gradients implicitly by scaling m
// Approximation of: m *= inversesqrt( a0*a0 + h*h );
  m *= 1.79284291400159 - 0.85373472095314 * ( a0*a0 + h*h );

// Compute final noise value at P
  vec3 g;
  g.x  = a0.x  * x0.x  + h.x  * x0.y;
  g.yz = a0.yz * x12.xz + h.yz * x12.yw;
  return 130.0 * dot(m, g);
}

uniform float time;
uniform float playerx;
uniform float playery;
uniform float timeOfLastDrum;

void main()
{
    //generate some directions from polar coords
    vec2 scrollDirection1 = vec2(0.0,0.0);
    scrollDirection1.x = cos(0.8);
    scrollDirection1.y = sin(0.8);

    vec2 scrollDirection2 = vec2(0.0,0.0);
    scrollDirection2.x = cos(-2.9);
    scrollDirection2.y = sin(-2.9);

	  vec2 uv = gl_TexCoord[0].xy;

    //drum distortion
    float drumming = time - timeOfLastDrum;
  
    if(drumming<0.5)
    {
      float dist = length(uv - vec2(playerx,playery))*20.0;
      
      if(dist>0.7)
      {
        drumming*=2.0;
        float distanceAtten = dist;
        dist = 1.0 /(dist*dist);
        vec2 dir = uv - vec2(playerx,playery);
        uv += dir*((cos(distanceAtten*5.0 - time*20.0)+1.0) * 0.5) *dist*(1.0-drumming) * 0.3;
      }
    }

	  vec4 pixel = texture2D(texture, uv);
    float val1 = 1.0 - snoise(uv + scrollDirection1*time);
    float val2 = 1.0 - snoise(uv*2.0 + scrollDirection2*0.5*time);
    float val3 = 1.0 - snoise(uv*100.0 + vec2(20.0*time,0.0));
    float val4 = 1.0 - snoise(uv*20.0 + vec2(3.0*time,0.0));

    vec4 overlay = pixel - ((vec4(val1,val1,val1,1.0) + vec4(val2,val2,val2,1.0) + vec4(val3,val3,val3,1.0)*0.1 + vec4(val4,val4,val4,1.0)*0.1)*0.25)*0.25;
    overlay.w = 1.0;
    gl_FragColor = overlay;

    //scanlines
    float scanline1 = abs(sin((uv.y+time*0.02)*300.0)) * 0.3;
    float scanline2 = abs(sin((uv.y+time*0.03)*200.0)) * 0.3;

    gl_FragColor -=scanline1*scanline2;

}
